<template>
<v-card outlined>
  <v-toolbar flat dense>
    <v-toolbar-title>
      Регистрация
    </v-toolbar-title>
    <v-spacer></v-spacer>
  </v-toolbar>
  <v-divider></v-divider>
  <v-card-text class="">
    <v-layout column class="">
      <span v-if="registrationStep == 2">1. </span>

      <!-- <h2 class="headline">Регистрация</h2> -->

      <v-form
        id="registerForm"
        action="request.path"
        method="POST"
        v-on:submit.prevent="register"
        >

        <!-- Email field (Register form) -->
        <v-text-field
          id="registerEmail"
          label="E-mail"
          type="email"
          name="email"
          v-model="signupEmail"
          v-bind:disabled="registrationStep == 2"
          required
          ></v-text-field>

        <!-- Register button -->
        <v-btn
          @click.prevent="signup"
          color="success2"
          :loading="loading"
          :disabled="loading"
          text
          >Зарегистрироваться
          <!-- <v-icon right dark>send</v-icon> -->
        </v-btn>

        <!-- Change registration email (start over) button -->
        <v-btn
          @click.prevent="registrationStep = 1; confirmCode=''; signupPassword=''"
          color="success"
          :loading="loading"
          :disabled="loading"
          v-if="registrationStep == 2"
          >Изменить email
          <v-icon right dark>send</v-icon>
        </v-btn>
      </v-form>


<!-- <div v-if="registrationStep == 2"> -->
<!--   <span class="card-title">2. Подтверждение аккаунта</span> -->

<!--   <b>{{ signupEmail }}</b> -->

<!--   <p>Вам на почту было отправлено письмо.</p> -->

<!--   <p>Введите сюда код из него или перейдите по ссылке в письме -->
<!--     для автоматического подтверждения.</p> -->

<!--   <v-form -->
<!--     id="confirmAccountForm" -->
<!--     action="request.path" -->
<!--     method="POST" -->
<!--     v-on:submit.prevent="confirmAccount" -->
<!--     > -->
<!--     <input -->
<!--       type="hidden" -->
<!--       name="email" -->
<!--       v-model="signupEmail" -->
<!--       > -->
<!--     <div class="input-field s12"> -->
<!--       <input -->
<!--         id="confirmCode" -->
<!--         required -->
<!--         type="text" -->
<!--         name="code" -->
<!--         v-bind:class="{ invalid: $data.lastInvalidCode = $data.confirmCode }" -->
<!--         v-model="confirmCode" -->
<!--         > -->
<!--       <label for="confirmCode">Код подтверждения</label> -->
<!--     </div> -->
<!--     <div class="input-field s12"> -->
<!--       <input -->
<!--         id="signupPassword" -->
<!--         required -->
<!--         type="password" -->
<!--         name="password" -->
<!--         autocomplete="new-password" -->
<!--         class="" -->
<!--         v-model="signupPassword" -->
<!--         > -->
<!--       <label for="confirmCode">Желаемый пароль</label> -->
<!--     </div> -->
<!--     <\!-- <div class="input-field s12"> -\-> -->
<!--     <\!--   <input -\-> -->
<!--     <\!--     id="password2" -\-> -->
<!--     <\!--     required -\-> -->
<!--     <\!--     type="password" -\-> -->
<!--     <\!--     name="password2" -\-> -->
<!--     <\!--     class="" -\-> -->
<!--     <\!--     v-model="password2" -\-> -->
<!--     <\!--   > -\-> -->
<!--     <\!--   <label for="confirmCode">Повторите пароль</label> -\-> -->
<!--     <\!-- </div> -\-> -->

<!--     <\!-- Confirm button -\-> -->
<!--     <button -->
<!--       class="btn waves-effect waves-light" -->
<!--       type="submit" -->
<!--       name="action" -->
<!--       >Подтвердить -->
<!--       <i class="material-icons right">send</i> -->
<!--     </button> -->
<!--     <\!-- v-bind:disabled="registrationStep == 2" -\-> -->
<!--   </v-form> -->
<!--   </div> -->
</v-layout>
</v-card-text>
    </v-card>
</template>

<script>
import Vue from 'vue';
import API from './api';
// import vuetify from '@/plugins/vuetify'
import { VTextField, VAlert, VBtn, VForm } from 'vuetify/lib';

export default {
  components: {
    // VTextField,
    // VAlert,
    // VBtn,
    // VForm,
  },
  data: () => ({
    confirmCode: '',
    lastInvalidCode: '',
    loading: false,
    submit: false,
    lastloginform: {
      email: null,
      password: null,
    },
    loginform: {
      login: '', // can be email (and in future - a phone)
      password: '',
    },
    registrationStep: 1,
    resettingPassword: false,
    signinMsgErr: '',
    signupEmail: '',
    signupPassword: '',
  }),
  methods: {
    resetPassword() {
      // toast({ html: 'todo reset pass' });
    },
    showSigninError(msg) {
      this.$data.signinMsgErr = msg;
    },

    // Register button
    async signup() {
      const email = this.$data.signupEmail;
      try {
        const response = await API.signup(email);
        // console.log(response);
        // this.$snackbar.show('ok');
      } catch (err) {
        this.$toast(err.message);
      }

//         variable: null,
//         // operationName: 'signup',
//       }).then((response) => {
//         const { data } = response;
//         const { errors } = data;
//         if (errors) {
//           errors.forEach((err) => {
//             // toast({ html: err.message });
//           });
//           // console.log(errors);
//         } else {
//           // No errors - a really new email (new user)
//           // toast({ html: 'Check your mail and activate account' });
//           this.$data.registrationStep = 2;
//         }
//       });
    },

    sendRestorePasswordToken() {
      const api = new API();
      api.graphql({
        query: `mutation restorePassword {
  restorePassword(email: "${this.$data.loginform.login}") {
    email
    jwt
  }
}`,
        variable: null,
        // operationName: 'signup',
      }).then((response) => {
        // GraphQL "login" mutation OK
        const { data } = response;
        const { errors } = data;
        if (errors) {
          errors.forEach((err) => {
            // toast({ html: err.message });
          });
          //
        } else {
          // No errors: email and password were valid!
          const user = data.data.login;
          // console.log(user);
          // toast({ html: user });
          // this.$data.registrationStep = 2;
        }
      });
      // toast({ html: 'token' });
    },
  },
};
</script>
